#include <AccelStepper.h>  //import AccelStepper library
#include <AFMotor.h>    // import Adafruit Motor Shield Library 

//setting AccelStepper working with Adafruit Motor Sield
AF_Stepper motor1(200, 1);  // set the first motor
AF_Stepper motor2(200, 2);  // set the second motor

// setting steps for the first motor
void forwardstep1() {  
  motor1.onestep(FORWARD, SINGLE);
}
void backwardstep1() {  
  motor1.onestep(BACKWARD, SINGLE);
}


// and for the second motor!
void forwardstep2() {  
  motor2.onestep(FORWARD, SINGLE);
}
void backwardstep2() {  
  motor2.onestep(BACKWARD, SINGLE);
}

AccelStepper Stepper1(forwardstep1, backwardstep1);
AccelStepper Stepper2(forwardstep2, backwardstep2);
// end settings for Adafruit

// Setting for my motor shield
//AccelStepper Stepper1(AccelStepper::FULL4WIRE, 4, 5, 6, 7);  // define pins
//AccelStepper Stepper2(AccelStepper::FULL4WIRE, 8, 9, 10, 11); // define pins
// End setting for my motor-shield
 




void setup()
{
  Serial.begin(9600);        //start serial at 9600 baudrate
  
  // satting some basic motor parameters for the first stepper
  Stepper1.setMaxSpeed(600);
  Stepper1.setAcceleration(200);
  Stepper1.setSpeed(0);       
  
  // satting some basic motor parameters for the second stepper
  Stepper2.setMaxSpeed(600);
  Stepper2.setAcceleration(200);
  Stepper2.setSpeed(0); 
 
 
 long x = 0L;          //x home
 long y = 0L;          // y home
 void SetPosition (long x, long y);  //set home
 
}
void loop()
{  
       // set some variables
       int TiltSpeed = 0;        
       int PanSpeed = 0;
       String IncomingByte;
 
       int gox = 0;
       int goy = 0;
       
       
       String dummy="#";
      
       Stepper1.runSpeed();
       Stepper2.runSpeed();
 
      
      String readString;                    // prepare the string
      while (Serial.available()) {          //loop
         delay(10);  
         if (Serial.available() >0) {       // check is there is a serial connection
           char c = Serial.read();          //gets one byte from serial buffer
           readString += c;                 //makes the string readString
           Serial.println(readString);      //print on screen
         } 
       }
      
      //readString = "#A1750B1750X1011Y1461";
      
      IncomingByte = readString.substring(0, 1);              //read the first character
      
      if (IncomingByte==dummy)                                //if is a # start reading
      {
             TiltSpeed=readString.substring(2, 6).toInt();    // jump a char (A), read next 4 chars, record it on a variable
             Serial.println(TiltSpeed);                       // print the variable value
             PanSpeed=readString.substring(7, 11).toInt();    // jump a char (B), read next 4 chars, record it on a variable
             Serial.println(PanSpeed);                        // print the variable value
             gox=readString.substring(12, 16).toInt();        // jump a char (X), read next 4 chars, record it on a variable
             Serial.println(gox);                             // print the variable value
             goy=readString.substring(17, 21).toInt();        // jump a char (Y), read next 4 chars, record it on a variable
             Serial.println(goy);                             // print the variable value
             SetSpeed(&Stepper1, TiltSpeed);                  // set the speed af the first motor
             SetSpeed(&Stepper2, PanSpeed);                   // set the speed af the second motor
             SetPosition(gox, goy);                           // move to point
      }

}

// function used to set the speed of the motor
void SetSpeed(AccelStepper* pStepper, int MotorSpeed)
{
      
      pStepper->setSpeed(MotorSpeed*30);          // adjust the motor speed
       
}
 
 
 // function that move the motors
void SetPosition(int x, int y)
{
       x=x*100;    //multiply for pulley or for simulate
       y=y*100;    //multiply for pulley or for simulate
       Stepper1.moveTo(x);
       Stepper2.moveTo(y);
       
       
       // trick that make fluid the movement
       while (abs(x - Stepper1.currentPosition()) > 0)
       {
              Stepper1.run();
              Stepper2.run();
       }
       
}
